import java.io.*;
import java.math.*;
import java.util.*;

public class merge_vv{
	
	Scanner in;
	PrintWriter out;
	
	public void run() throws Exception{
		in = new Scanner(new File("merge.in"));
		out = new PrintWriter(new FileWriter(new File("merge.out")));
		int n = in.nextInt(); if (n>100) throw new RuntimeException("Too big");
		int m = in.nextInt(); if (m>100) throw new RuntimeException("Too big");
		int[] a = new int[n];
		for(int i=0;i<n;i++)
			a[i] = in.nextInt();
		for(int i=0;i<n;i++)
			for(int j=i+1;j<n;j++)
				if (a[i]==a[j]) throw new RuntimeException("Same numbers");
		int[] b = new int[m];
		for(int j=0;j<m;j++)
			b[j] = in.nextInt();
		for(int i=0;i<m;i++)
			for(int j=i+1;j<m;j++)
				if (b[i]==b[j]) throw new RuntimeException("Same numbers");
		int mm = n+5;
		BigInteger[][][] c = new BigInteger[2][n+1][mm+1];
		for(int i=1;i<=mm;i++) c[0][0][i] = BigInteger.ONE;
		c[0][0][0] = BigInteger.ZERO;
		int cc = 0;
		BigInteger[][] r = new BigInteger[n+1][n+1];
		for(int i=0;i<=n;i++){
			for(int j=0;j<=n;j++) if (i!=0 || j!=0){
				for(int k=1;k<=mm;k++){
					c[cc][j][k] = BigInteger.ZERO;
					if (i>0 && k+1<=mm) c[cc][j][k] = c[cc][j][k].add(c[1-cc][j][k+1]);
					if (j>0 && k>1) c[cc][j][k] = c[cc][j][k].add(c[cc][j-1][k-1]);
				}
				r[i][j] = c[cc][j][1];
			}
			cc = 1-cc;
		}
		r[0][0] = BigInteger.ONE;
		BigInteger[][] res = new BigInteger[n+1][m+1];
		for(int i=0;i<=n;i++)
			for(int j=0;j<=m;j++)
				if (i==n || j==m) res[i][j] = BigInteger.ONE;
				else res[i][j] = BigInteger.ZERO;
		for(int i=n-1;i>=0;i--){
			for(int j=m-1;j>=0;j--){
				res[i][j] = res[i+1][j];
				int k = 0;
				while (i+k<n && j+k<m && a[i+k]==b[j+k]) k++;
				if (j+k<m) if (k!=0) for(int l=0;l<k && i+l<n;l++){ 
					res[i][j] = res[i][j].add(res[i+l][j+k+1].multiply(r[k-1][l]));
				} else res[i][j] = res[i][j].add(res[i][j+1]);
			}
		}
		out.println(res[0][0]);
		//System.out.println(res[0][0]);
	}
	
	public void close(){
		out.close();
	}
	
	
	public static void main(String[] args) throws Exception{
		new Thread(){
			public void run(){
				try{
					merge_vv u = new merge_vv();
					u.run();
					u.close();
				} catch (Exception E){
					throw new RuntimeException(E);
				}
			}
		}.start();

	}
}
